Subject: Re: Changes to PPC Linux required for GCC 3.1

From: Daniel Jacobowitz <[email-masked]>
Date: Wed, 5 Dec 2001 15:17:21 -0500

On Wed, Dec 05, 2001 at 10:37:28AM -0700, Tom Rini wrote:
>
> On Wed, Dec 05, 2001 at 10:18:26AM -0600, Corey Minyard wrote:
> >
> > Franz Sirl wrote:
> >
> > >
> > >I've done
> > >
> > >-#define RELOC(x)       (*PTRRELOC(&(x)))
> > >+#define RELOC(x)       (*({ typeof(x) * __ptr  = PTRRELOC(&(x));
> > >__asm__ ("" : "=r" (__ptr) : "0" (__ptr)); __ptr;}))
> > >
> > >a while ago in
> > ><http://source.mvista.com/pipermail/linuxppc-commit/2001-September/000729.html>,
> > >seems nobody applied it so far.
> >
> > Ok.  It needs to be propped.
>
> I think the reason this wasn't applied is that Paul said something about
> thiws being horriyingly ugly.  Corey, can you post a patch that changes
> RELOC(x) into a function and nothing else? :)

Has either of you tried to boot a kernel in which RELOC is a function?
If I'm following any of what's going on here, function symbols are
global.  To call the function you would need to use RELOC.

--
Daniel Jacobowitz                           Carnegie Mellon University
MontaVista Software                         Debian GNU/Linux Developer

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/